package org.diagbot.nlp.feature.extract;

import org.diagbot.nlp.participle.word.Lexeme;
import org.diagbot.nlp.participle.word.LexemePath;
import org.diagbot.nlp.util.Constants;
import org.diagbot.nlp.util.NegativeEnum;
import org.diagbot.nlp.util.NlpUtil;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

public class CaseTokenFeature extends CaseToken {
    private NegativeEnum[] nees_symptom = new NegativeEnum[]{NegativeEnum.SYMPTOM,
            NegativeEnum.BODY_PART, NegativeEnum.PROPERTY, NegativeEnum.DEEP,
            NegativeEnum.CAUSE, NegativeEnum.DISEASE, NegativeEnum.VITAL_RESULT, NegativeEnum.LIS_RESULT,
            NegativeEnum.PACS_RESULT};

    {
        stop_symbol = NlpUtil.extendsSymbol(stop_symbol, new String[]{",", "，", ":", "："});
        Arrays.sort(stop_symbol);
    }

    public List<Map<String, Object>> analyze(LexemePath<Lexeme> lexemePath) throws Exception {
        super.sn = 0;
        //词性
        String property = null;
        List<Map<String, Object>> featuresList = new ArrayList<>();
        for (int index = 0; index < lexemePath.size(); index++) {
            Lexeme lexeme = lexemePath.get(index);
            property = lexeme.getProperty();
            if (NlpUtil.isFeature(property, nees_symptom)) {          //特征词 症状
                lookFeatures(featuresList, index, lexemePath, lexeme, Constants.feature_type_feature, nees_symptom, true);
            }
        }
        return featuresList;
    }
}
